#include <at892051.h>
#include "indicator.h"

sbit TRIAC = P3^7;
sbit KEY = P3^5;

unsigned char delay;
unsigned char uskor=9;
unsigned char tic_uskor=5;

bit key_trig=1;
bit nap;
bit nap_copy;

bit clr_ind;
bit isr;

unsigned char  div_SS=7;
unsigned char tik_SS=199;

unsigned char  set_on=100;
	
unsigned int time=18090;

bit izmerenie; //flag nachala izmereniya poluperioda seti. 
bit zerro_error=0; //flag oshibki skhemy detektora perekhoda cherez "0". 
bit gotov=0; //flag gotovnosti izmereniya poluperioda seti. 

bit no_zerro=0; //flag oshibki izmereniya poluperioda seti. Dostoveren ot 41 Gts do 62,5 Gts (poluvolna ot 300 do 450). 374=50Hz 312=60Hz 468=40Hz 
unsigned int takt=0; //podschet taktov v poluperiode dlya sravneniya s zadaniyem 
unsigned char pause=150; //schetchik zaderzhki vklyucheniya pered plavnym puskom ili oshibkoy rascheta poluperioda. 
unsigned int sector; //rezul'tat i-go izmereniya poluperioda dlya rascheta yego dlinny. 
unsigned int set_prc=0; //zadaniye ugla vyrazhennoye v protsentakh ot 0% do 100%. 
unsigned int set_sector; //zadaniye ugla. Pri prevyshenii taktov (takt) vklyuchayet simistor. 
unsigned int sum_sector; //Summa rezul'tatov izmereniya poluvoln. 
unsigned char cycle; //chislo tsiklov izmereniya poluvolny. 
unsigned int poluvolna; //rezul'tat izmereniya poluvolny. 
unsigned char fors; //uskoreniye otkrytiya


void INT0Isr (void) interrupt 0 using 1 { 
	EX0 = 0;
	takt=0;
	
if(!zerro_error)
  { 
    if(!izmerenie)
     {
      sector=0;
     }
      else
          {
            if(cycle>127)
              {
                poluvolna=sum_sector>>7;
								
                if((poluvolna>150)||(poluvolna<50))
                  {
                  no_zerro=1;
                  }
                  else
                  {
                  no_zerro=0;zerro_error=0;
                  };
                  
                gotov=1;
                sum_sector=sector=cycle=0;
              }
              else
                {
                  sum_sector=sum_sector+sector;
									cycle++;
                };
          };
          
  izmerenie=~izmerenie;
	TL0 = 0;
 };

 isr=EX0 = 1;
}


void T0Isr(void) interrupt 1 using 2 {
	
TF0 = 0;
takt++;

sector++;
    
   if(sector>250)
     {
      zerro_error=1;
      TRIAC=1;
     };
              
        
    if((gotov)&&(!no_zerro)&&(!pause)&&(!zerro_error))
      { 
				
				if(set_prc==100){TRIAC=~TRIAC;}else{
					
        if((takt>set_sector)&&(takt<poluvolna-5))       //if((takt>set_sector)&&(takt<poluvolna-5))
        
         {         
           TRIAC=~TRIAC;
         }
				 else
							{
								TRIAC=1;
							};

          };
      }
      else
      {
      TRIAC=1;
      set_sector=65000;
      };
	
}

//void T1Isr(void) interrupt 3 using 1 {
//	TF1 = 0;

//}

void main(void)
{

TH0 = 159; //150=24mhz
//TL0 = 0x00; 
TMOD = 2; 
ET0 = 1;
//ET1 = 1;
IT0   =   1; 
EX0   =   1;	
EA = 1;
TR0 = 1;
//TR1 = 1;
 	
IND_Init();
	
	
while (1)
   {
if(isr){

  if(pause)
        {
        pause++;
        };
				
	if(delay){delay++;if(delay>uskor){delay=0;};};
	
	
  if(gotov){if(time){time--;if(time==1){set_prc=set_on=50;IND_OutputFormat(set_prc, 0, 1, 3);};};
	
	if(div_SS){div_SS--;};
	
  if(!div_SS){if(!pause){if(tik_SS){tik_SS--;if(set_prc<set_on){set_prc++;}else{set_prc=set_on;};};};div_SS=7;};
					};
	isr=0;
};
    if(zerro_error)
    { 
      sector=zerro_error=set_prc=0;
			gotov=0;
			tik_SS=199;
    }
     else
     {
			 
if(!gotov){IND_TIRE();	clr_ind=1;};	    
			
      if(key_trig!=KEY){if(time){IND_CLR();};time=0;key_trig=KEY;if(!KEY){if(!delay){nap=~nap;delay++;if(nap){IND_CLR();}else{IND_TIRE();};};};};   //


if(gotov){

					if(clr_ind){IND_CLR();clr_ind=0;IND_OutputFormat(set_prc, 0, 1, 3);};
					
					if(!KEY){
									if(!delay){
														delay++;
														if(nap){
																		if(set_prc<100){set_prc++;};
																		}else{
																		if(set_prc){set_prc--;};
																		};
														set_on=set_prc;


												if((set_prc==48)||(set_prc==52)){uskor=9;nap_copy=nap;tic_uskor=4;};						
											if(nap!=nap_copy){uskor=9;nap_copy=nap;tic_uskor=4;}else{tic_uskor--;if(!tic_uskor){if(uskor>2){uskor--;};tic_uskor=4;};};			
									
									};
									};
					
	set_sector=(poluvolna-(poluvolna*set_prc)/100);
									
									
				if(time){
								IND_OutputFormat(0, 0, 4, 1);
								IND_OutputFormat((time/100)/60, 3, 3, 1);
								IND_OutputFormat((time/100)%60, 0, 1, 2);
					      if(((time/100)%60)<10){IND_OutputFormat(0, 0, 2, 1);};
								if(time==1){IND_CLR();};
								}else{
									IND_OutputFormat(set_prc, 0, 1, 3);	
									};			

				};

			};
IND_Update();
}
}