#include "indicator.h"

#include <at892051.h>

#define read_byte_flash(x) (x)

#define IND_LIGHT_OUT 0xff

#if (IND_ACTIVE_LEVEL_SEG == 0)
   #define IND_OutSeg(port, value) port &= ~(value)
   #define IND_LightOutSeg(port, value) port |= (value)
#else 
   #define IND_OutSeg(port, value) port |= (value)
   #define IND_LightOutSeg(port, value) port &= ~(value)
#endif

#if (IND_ACTIVE_LEVEL_DIG == 0)
   #define IND_OutDig(port, value) port &= ~(value)
   #define IND_LightOutDig(port, value) port |= (value)
#else 
   #define IND_OutDig(port, value) port |= (value)
   #define IND_LightOutDig(port, value) port &= ~(value)
#endif

#define IND_EMPTY_NUM 10
#define IND_TIRE_NUM  11

/*bufer 7-mi segmetnogo indikatora*/
unsigned char ind_buf[IND_AMOUNT_NUM];

/*tablitsa perekodirovki*/
unsigned char number[] = 
{
  (1<<IND_A)|(1<<IND_B)|(1<<IND_C)|(1<<IND_D)|(1<<IND_E)|(1<<IND_F)|(0<<IND_G), //0
  (0<<IND_A)|(1<<IND_B)|(1<<IND_C)|(0<<IND_D)|(0<<IND_E)|(0<<IND_F)|(0<<IND_G), //1
  (1<<IND_A)|(1<<IND_B)|(0<<IND_C)|(1<<IND_D)|(1<<IND_E)|(0<<IND_F)|(1<<IND_G), //2
  (1<<IND_A)|(1<<IND_B)|(1<<IND_C)|(1<<IND_D)|(0<<IND_E)|(0<<IND_F)|(1<<IND_G), //3   
  (0<<IND_A)|(1<<IND_B)|(1<<IND_C)|(0<<IND_D)|(0<<IND_E)|(1<<IND_F)|(1<<IND_G), //4
  (1<<IND_A)|(0<<IND_B)|(1<<IND_C)|(1<<IND_D)|(0<<IND_E)|(1<<IND_F)|(1<<IND_G), //5 
  (1<<IND_A)|(0<<IND_B)|(1<<IND_C)|(1<<IND_D)|(1<<IND_E)|(1<<IND_F)|(1<<IND_G), //6
  (1<<IND_A)|(1<<IND_B)|(1<<IND_C)|(0<<IND_D)|(0<<IND_E)|(0<<IND_F)|(0<<IND_G), //7   
  (1<<IND_A)|(1<<IND_B)|(1<<IND_C)|(1<<IND_D)|(1<<IND_E)|(1<<IND_F)|(1<<IND_G), //8
  (1<<IND_A)|(1<<IND_B)|(1<<IND_C)|(1<<IND_D)|(0<<IND_E)|(1<<IND_F)|(1<<IND_G), //9    
  (0<<IND_A)|(0<<IND_B)|(0<<IND_C)|(0<<IND_D)|(0<<IND_E)|(0<<IND_F)|(0<<IND_G), //IND_EMPTY_NUM 
  (0<<IND_A)|(0<<IND_B)|(0<<IND_C)|(0<<IND_D)|(0<<IND_E)|(0<<IND_F)|(1<<IND_G)  //IND_TIRE_NUM   
};

unsigned char digit[] = 
{
   IND_NUM1,  
   IND_NUM2,
   IND_NUM3,   
   IND_NUM4,  
   IND_NUM5,  
   IND_NUM6,
   IND_NUM7,   
   IND_NUM8  
};



/******************************************************************************/
void IND_Init(void)
{
  unsigned char i;

  for(i = 0; i < IND_AMOUNT_NUM; i++) {
     ind_buf[i] = 0;
  }
}

/******************************************************************************/
void IND_TIRE(void)
{
  unsigned char i;
  for(i = 0; i < IND_AMOUNT_NUM; i++){
       ind_buf[i] = read_byte_flash(number[IND_TIRE_NUM]);  
  }
}

/******************************************************************************/

/******************************************************************************/
void IND_CLR(void)
{
  unsigned char i;
  for(i = 0; i < IND_AMOUNT_NUM; i++){
       ind_buf[i] = read_byte_flash(number[IND_EMPTY_NUM]);  
  }
}

/******************************************************************************/

/******************************************************************************/
void IND_Output(unsigned int value, unsigned char comma)
{
  unsigned char tmp;    
  unsigned char i;
  
  
  for(i = 0; i < IND_AMOUNT_NUM; i++){
    tmp = value % 10;
    if ((i == 0)||(value > 0)||(i <= comma)){ 
       ind_buf[i] = read_byte_flash(number[tmp]);
    }
    else{
       ind_buf[i] = read_byte_flash(number[IND_EMPTY_NUM]);  
    }
    value = value/10;
  }
  
  if ((comma <= IND_AMOUNT_NUM) && (comma != 0)) {
    ind_buf[comma-1] |= 1<<IND_COM;
  }
}

/******************************************************************************/
void IND_OutputFormat(unsigned int value, unsigned char comma, unsigned char position, unsigned char amount)
{
  unsigned char tmp;
  unsigned char i;
  
  if ((position <= IND_AMOUNT_NUM)&&(position != 0)){
     for(i = 0; i < amount; i++){
        tmp = value % 10;
        if ((i == 0)||(value > 0)||(position <= comma)){ 
           ind_buf[position-1] = read_byte_flash(number[tmp]);
        }
        else{
           ind_buf[position-1] = read_byte_flash(number[IND_EMPTY_NUM]);
        }      
        value = value/10;
        position++;
        if (position > IND_AMOUNT_NUM){
           break;
        } 
     }
  }
     
  if ((comma <= IND_AMOUNT_NUM) && (comma != 0)) {
    ind_buf[comma-1] |= 1<<IND_COM;
  }
}

/******************************************************************************/
void IND_Update(void)
{
  static unsigned char count = 0;     
  unsigned char i;
  unsigned char tmp; 
  
 /*gasim vse indikatory*/
 IND_LightOutSeg(IND_PORT_SEG, IND_LIGHT_OUT);
 
 tmp = 0;
 for (i = 0; i < IND_AMOUNT_NUM; i++){
    tmp |= (1<<read_byte_flash(digit[i]));  
 }
 IND_LightOutDig(IND_PORT_DIG, tmp);
   

 /*____________realizatsi porazryadnoy razvertki____________*/  
  
  IND_OutDig(IND_PORT_DIG, (1<<read_byte_flash(digit[count])));
  IND_OutSeg(IND_PORT_SEG, ind_buf[count]);
  
  count++;
  if (count >= IND_AMOUNT_NUM){
     count = 0;  
  }


}
